unit tdpc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, Gauges;
type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Konec1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Otevtvzor1: TMenuItem;
    Image1: TImage;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label1: TLabel;
    Bevel4: TBevel;
    Button1: TButton;
    image2: TImage;
    Label2: TLabel;
    OtevtBMP1: TMenuItem;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Image3: TImage;
    Label3: TLabel;
    Gauge1: TGauge;
    UloitBMP1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Bevel7: TBevel;
    Info1: TMenuItem;
    procedure Konec1Click(Sender: TObject);
    procedure Otevtvzor1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure zobrazpole;
    procedure start(Sender: TObject);
    procedure proved_radek(a:integer;rad:array of byte);
    procedure OtevtBMP1Click(Sender: TObject);
    procedure UloitBMP1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  jmeno: string;

implementation
uses about;
{$R *.DFM}

procedure TForm1.Konec1Click(Sender: TObject);
begin
     close
end;


procedure TForm1.Otevtvzor1Click(Sender: TObject);
begin
     if opendialog1.execute then image1.Picture.Bitmap.LoadFromFile(opendialog1.filename);


end;

procedure tform1.zobrazpole;
var a,b:trect;
    i:integer;
begin
     with a do begin
                left:=16;
                right:=76;
                top:=40;
                bottom:=80;
               end;
     with b do begin
                left:=300;
                right:=300+60;
               end;
     for i:=0 to 11 do begin
                           with b do begin
                            top:=i*40;
                            bottom:=i*40+40;
                           end;
                           image2.canvas.copyrect(b,Canvas,a);
                      end;
end;

procedure tform1.proved_radek(a:integer;rad:array of byte);
var i,b,c:integer;
begin
      for i:=300 downto 0 do begin
                                  b:=rad[i+60] div 16;
                                    c:=i+60-b+8;
                                    with image2.canvas do begin
                                     if c>359 then pixels[i,a]:=pixels[-60+c,a]
                                     else pixels[i,a]:=pixels[c,a];
                                    end;
                                   end;
       for i:=359 to image2.Width do begin
                                    b:=rad[i] div 16;
                                    c:=i-60+b-8;
                                    with image2.canvas do begin
                                    pixels[i,a]:=pixels[c,a];
                                    end;
                                   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
    radek:array [0..639] of byte;
    f:file;
begin
     if jmeno='' then exit;
     zobrazpole;
     image2.Visible:=false;
     assignfile(f,jmeno);
     reset(f,1);
     seek(f,1078);
     for i:=0 to 479 do begin
                         blockread(f,radek,sizeof(radek));
                         proved_radek(479-i,radek);
                         gauge1.progress:=round(i*100/480);
                        end;
     closefile(F);
     image2.Visible:=true;
     gauge1.progress:=0;
end;

procedure TForm1.start(Sender: TObject);
begin
     image1.Picture.Bitmap.LoadFromFile('vzor.bmp');
     button1.enabled:=false;
end;

procedure TForm1.OtevtBMP1Click(Sender: TObject);
begin
     if opendialog1.execute then begin
                                 jmeno:=opendialog1.filename;
                                 label2.Caption:=jmeno;
                                 image3.Picture.Bitmap.LoadFromFile(jmeno);
                                 button1.enabled:=true;
                                end;
end;

procedure TForm1.UloitBMP1Click(Sender: TObject);
begin
     if savedialog1.execute then image2.picture.Bitmap.SaveToFile(savedialog1.filename+'.bmp')
end;

procedure TForm1.Info1Click(Sender: TObject);
var
  about: TAboutBox;
begin
  about := TAboutBox.Create(Self);
  try
    about.ShowModal;
  finally
    about.Free;
  end;
end;

end.
